/***************************************************************************
                          dragstack.cpp  -  description
                             -------------------
    begin                : Don Okt 30 09:53:28 CET 2003
    copyright            : (C) 2003 by Dominik Seichter
    email                : domseichter@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kglobal.h>
#include <klocale.h>
#include <kapp.h>
#include <kaboutapplication.h>

#include "dragstack.h"
#include "dspushbutton.h"

#define ADDITION 4

extern "C"
{
  KPanelApplet* init( QWidget *parent, const QString configFile)
  {
    KGlobal::locale()->insertCatalogue("dragstack");
    return new DragStacK(configFile, KPanelApplet::Normal,
                      KPanelApplet::About,
                      parent, "dragstack");
  }
}

DragStacK::DragStacK(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
       : KPanelApplet(configFile, type, actions, parent, name)
{
    m_button = new DSPushButton( this );
    connect( m_button, SIGNAL( about() ), this, SLOT( about() ) );    
}

void DragStacK::resizeEvent( QResizeEvent* e )
{
    int size = 0;

    KPanelApplet::resizeEvent( e );
    
    if(orientation() == Vertical)
    {
        size = width();
    }
    else
    {
        size = height();
    }
    
    m_button->resize(size, size);
    m_button->updateIcon();
}

void DragStacK::about()
{
  KAboutData about
    (
     "dragstack",
     I18N_NOOP("DragStacK"),
     VERSION,
     I18N_NOOP(
     "<qt>DragStacK is a kicker applet. You can drop as many files on it "
     "as you want. Do get the files out of the stack just drag them out "
     "of it. The last file you dropped on the stack is the first file you "
     "can drag out of it. DragStacK does not keep the files themselves "
     "in the stack but only their paths.</qt>"
    ),
     KAboutData::License_GPL_V2,
     "(C) 2003 Dominik Seichter", 0,  "domseichter@web.de"
   );

   about.addAuthor("Dominik Seichter", 0, "domseichter@web.de", "http://www.krename.net" );
       
  KAboutApplication a(&about);
  a.exec();
}

int DragStacK::widthForHeight( int h) const
{
   return h+ADDITION;
}

int DragStacK::heightForWidth( int w ) const
{
   return w-ADDITION;
}

